﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel;

namespace PollResultsBarDemo
{
    public class PollResultsBar : ProgressBar
    {


        public static readonly DependencyProperty LeftValueProperty =
             DependencyProperty.Register("LeftValue",
                                             typeof(int),
                                             typeof(PollResultsBar),
                                             new PropertyMetadata(0, new PropertyChangedCallback(OnLeftValueChanged)));

        public static readonly DependencyProperty RightValueProperty =
             DependencyProperty.Register("RightValue",
                                             typeof(int),
                                             typeof(PollResultsBar),
                                             new PropertyMetadata(0, new PropertyChangedCallback(OnRightValueChanged)));



        public int LeftValue
        {
            get { return (int)base.GetValue(LeftValueProperty); }
            set { base.SetValue(LeftValueProperty, value); }
        }

        public int RightValue
        {
            get { return (int)base.GetValue(RightValueProperty); }
            set { base.SetValue(RightValueProperty, value); }
        }

        private new double Maximum
        {
            set { base.Maximum = value; }
            get { return base.Maximum; }
        }

        public static void OnLeftValueChanged(DependencyObject d, DependencyPropertyChangedEventArgs e)
        {
            SetValue(d as PollResultsBar, (int)e.NewValue);
            SetMaximum(d as PollResultsBar);
        }

        public static void SetValue(PollResultsBar bar, int value)
        {
            bar.Value = value;
        }

        public static void OnRightValueChanged(DependencyObject d, DependencyPropertyChangedEventArgs e)
        {
            SetMaximum(d as PollResultsBar);
        }

        private static void SetMaximum(PollResultsBar bar)
        {
            bar.Maximum = bar.LeftValue + bar.RightValue;
        }


    }
}
