﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Windows.Interactivity;
using System.ComponentModel;
//using Microsoft.Expression.Interactivity.Core;

namespace PollResultsBarDemo
{
	public class PollResultsBarBehavior : Behavior<DependencyObject>
	{
        ProgressBar _progressBar;

		public PollResultsBarBehavior()
		{
		}

		protected override void OnAttached()
		{
			base.OnAttached();
             _progressBar = AssociatedObject as ProgressBar;
		}

		protected override void OnDetaching()
		{
			base.OnDetaching();
		}

        public static readonly DependencyProperty LeftValueProperty =
             DependencyProperty.Register("LeftValue",
                                             typeof(int),
                                             typeof(PollResultsBarBehavior),
                                             new PropertyMetadata(50, new PropertyChangedCallback(OnLeftValueChanged)));

        public static readonly DependencyProperty RightValueProperty =
             DependencyProperty.Register("RightValue",
                                             typeof(int),
                                             typeof(PollResultsBarBehavior),
                                             new PropertyMetadata(50, new PropertyChangedCallback(OnRightValueChanged)));



        public int LeftValue
        {
            get { return (int)base.GetValue(LeftValueProperty); }
            set { base.SetValue(LeftValueProperty, value); }
        }

        public int RightValue
        {
            get { return (int)base.GetValue(RightValueProperty); }
            set { base.SetValue(RightValueProperty, value); }
        }


        public static void OnLeftValueChanged(DependencyObject d, DependencyPropertyChangedEventArgs e)
        {
            SetMaximum(d as PollResultsBarBehavior);
            SetValue(d as PollResultsBarBehavior, (int)e.NewValue);
        }

        public static void SetValue(PollResultsBarBehavior bar, int value)
        {
            if (DesignerProperties.GetIsInDesignMode(Application.Current.RootVisual))
                return;

            if (bar._progressBar != null)
                bar._progressBar.Value = value;
        }

        public static void OnRightValueChanged(DependencyObject d, DependencyPropertyChangedEventArgs e)
        {
            SetMaximum(d as PollResultsBarBehavior);
        }

        private static void SetMaximum(PollResultsBarBehavior bar)
        {
            if (DesignerProperties.GetIsInDesignMode(Application.Current.RootVisual))
                return;

            if (bar._progressBar != null)
                bar._progressBar.Maximum = bar.LeftValue + bar.RightValue;
        }


    }
}