﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.ComponentModel;

namespace PollResultsBarDemo
{
    public class MainPageViewModel : INotifyPropertyChanged
    {
        #region PollResultsList
        private ObservableCollection<PollResults> _PollResultsList;
        public ObservableCollection<PollResults> PollResultsList
        {
            get { return this._PollResultsList; }
            set
            {
                if (this._PollResultsList != value)
                {
                    this._PollResultsList = value;
                    this.NotifyPropertyChanged("PollResultsList");
                }
            }
        }
        #endregion

        public MainPageViewModel()
        {
            PollResultsList = PollResultsBarDemoModel.GetPollResults();
        }

        #region INotifyPropertyChanged
        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }
        #endregion
    }
}
